/* Patch for Bahamut - Spoofing Support 
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * Copyright (c) 2002 Rodrigo Gimnez
 * All rights reserved.
 * Contact me at: kyotou@jpchat.net
 */
 
#define PRINT_C   0x001
#define CNTRL_C   0x002
#define ALPHA_C   0x004
#define PUNCT_C   0x008
#define DIGIT_C   0x010
#define SPACE_C   0x020
#define NICK_C    0x040
#define CHAN_C    0x080
#define KWILD_C   0x100
#define CHANPFX_C 0x200
#define USER_C    0x400
#define HOST_C    0x800
#define NONEOS_C 0x1000
#define SERV_C   0x2000
#define EOL_C    0x4000
#ifdef KOREAN
#define HANGUL_C 0x8000
#endif
#define IsDigit(c)      (CharAttrs[(unsigned char)(c)] & DIGIT_C)

const unsigned int CharAttrs[] = {
/* 0  */     CNTRL_C,
/* 1  */     CNTRL_C|NONEOS_C,
/* 2  */     CNTRL_C|NONEOS_C,
/* 3  */     CNTRL_C|NONEOS_C,
/* 4  */     CNTRL_C|NONEOS_C,
/* 5  */     CNTRL_C|NONEOS_C,
/* 6  */     CNTRL_C|NONEOS_C,
/* 7 BEL */  CNTRL_C|NONEOS_C,
/* 8  \b */  CNTRL_C|NONEOS_C,
/* 9  \t */  CNTRL_C|SPACE_C|NONEOS_C,
/* 10 \n */  CNTRL_C|SPACE_C|NONEOS_C|EOL_C,
/* 11 \v */  CNTRL_C|SPACE_C|NONEOS_C,
/* 12 \f */  CNTRL_C|SPACE_C|NONEOS_C,
/* 13 \r */  CNTRL_C|SPACE_C|NONEOS_C|EOL_C,
/* 14 */     CNTRL_C|NONEOS_C,
/* 15 */     CNTRL_C|NONEOS_C,
/* 16 */     CNTRL_C|NONEOS_C,
/* 17 */     CNTRL_C|NONEOS_C,
/* 18 */     CNTRL_C|NONEOS_C,
/* 19 */     CNTRL_C|NONEOS_C,
/* 20 */     CNTRL_C|NONEOS_C,
/* 21 */     CNTRL_C|NONEOS_C,
/* 22 */     CNTRL_C|NONEOS_C,
/* 23 */     CNTRL_C|NONEOS_C,
/* 24 */     CNTRL_C|NONEOS_C,
/* 25 */     CNTRL_C|NONEOS_C,
/* 26 */     CNTRL_C|NONEOS_C,
/* 27 */     CNTRL_C|NONEOS_C,
/* 28 */     CNTRL_C|NONEOS_C,
/* 29 */     CNTRL_C|NONEOS_C,
/* 30 */     CNTRL_C|NONEOS_C,
/* 31 */     CNTRL_C|NONEOS_C,
/* SP */     PRINT_C|SPACE_C,
/* ! */      PRINT_C|KWILD_C|CHAN_C|NONEOS_C,
/* " */      PRINT_C|CHAN_C|NONEOS_C,
/* # */      PRINT_C|CHANPFX_C|CHAN_C|NONEOS_C,
/* $ */      PRINT_C|CHAN_C|NONEOS_C|USER_C,
/* % */      PRINT_C|CHAN_C|NONEOS_C,
/* & */      PRINT_C|CHANPFX_C|CHAN_C|NONEOS_C,
/* ' */      PRINT_C|CHAN_C|NONEOS_C,
/* ( */      PRINT_C|CHAN_C|NONEOS_C,
/* ) */      PRINT_C|CHAN_C|NONEOS_C,
/* * */      PRINT_C|KWILD_C|CHAN_C|NONEOS_C|SERV_C,
/* + */      PRINT_C|CHAN_C|NONEOS_C,
/* , */      PRINT_C|NONEOS_C,
/* - */      PRINT_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
#ifdef ALLOW_DOT_IN_IDENT
/* . */      PRINT_C|KWILD_C|CHAN_C|NONEOS_C|USER_C|HOST_C|SERV_C,
#else
/* . */      PRINT_C|KWILD_C|CHAN_C|NONEOS_C|HOST_C|SERV_C,
#endif
#ifdef RFC1035_ANAL
/* / */      PRINT_C|CHAN_C|NONEOS_C,
#else
/* / */      PRINT_C|CHAN_C|NONEOS_C|HOST_C,
#endif
/* 0 */      PRINT_C|DIGIT_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* 1 */      PRINT_C|DIGIT_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* 2 */      PRINT_C|DIGIT_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* 3 */      PRINT_C|DIGIT_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* 4 */      PRINT_C|DIGIT_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* 5 */      PRINT_C|DIGIT_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* 6 */      PRINT_C|DIGIT_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* 7 */      PRINT_C|DIGIT_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* 8 */      PRINT_C|DIGIT_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* 9 */      PRINT_C|DIGIT_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* : */      PRINT_C|CHAN_C|NONEOS_C|HOST_C,
/* ; */      PRINT_C|CHAN_C|NONEOS_C,
/* < */      PRINT_C|CHAN_C|NONEOS_C,
/* = */      PRINT_C|CHAN_C|NONEOS_C,
/* > */      PRINT_C|CHAN_C|NONEOS_C,
/* ? */      PRINT_C|KWILD_C|CHAN_C|NONEOS_C,
/* @ */      PRINT_C|KWILD_C|CHAN_C|NONEOS_C,
/* A */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* B */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* C */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* D */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* E */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* F */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* G */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* H */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* I */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* J */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* K */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* L */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* M */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* N */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* O */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* P */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* Q */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* R */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* S */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* T */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* U */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* V */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* W */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* X */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* Y */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* Z */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* [ */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C,
/* \ */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C,
/* ] */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C,
/* ^ */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C,
#ifdef RFC1035_ANAL
/* _ */      PRINT_C|NICK_C|CHAN_C|NONEOS_C|USER_C,
#else
/* _ */      PRINT_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
#endif
/* ` */      PRINT_C|NICK_C|CHAN_C|NONEOS_C|USER_C,
/* a */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* b */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* c */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* d */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* e */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* f */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* g */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* h */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* i */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* j */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* k */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* l */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* m */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* n */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* o */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* p */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* q */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* r */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* s */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* t */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* u */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* v */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* w */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* x */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* y */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* z */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C|HOST_C,
/* { */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C,
/* | */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C,
/* } */      PRINT_C|ALPHA_C|NICK_C|CHAN_C|NONEOS_C|USER_C,
/* ~ */      PRINT_C|ALPHA_C|CHAN_C|NONEOS_C|USER_C,
/* del  */   CHAN_C|NONEOS_C,
/* 0x80 */   CHAN_C|NONEOS_C,
/* 0x81 */   CHAN_C|NONEOS_C,
/* 0x82 */   CHAN_C|NONEOS_C,
/* 0x83 */   CHAN_C|NONEOS_C,
/* 0x84 */   CHAN_C|NONEOS_C,
/* 0x85 */   CHAN_C|NONEOS_C,
/* 0x86 */   CHAN_C|NONEOS_C,
/* 0x87 */   CHAN_C|NONEOS_C,
/* 0x88 */   CHAN_C|NONEOS_C,
/* 0x89 */   CHAN_C|NONEOS_C,
/* 0x8A */   CHAN_C|NONEOS_C,
/* 0x8B */   CHAN_C|NONEOS_C,
/* 0x8C */   CHAN_C|NONEOS_C,
/* 0x8D */   CHAN_C|NONEOS_C,
/* 0x8E */   CHAN_C|NONEOS_C,
/* 0x8F */   CHAN_C|NONEOS_C,
/* 0x90 */   CHAN_C|NONEOS_C,
/* 0x91 */   CHAN_C|NONEOS_C,
/* 0x92 */   CHAN_C|NONEOS_C,
/* 0x93 */   CHAN_C|NONEOS_C,
/* 0x94 */   CHAN_C|NONEOS_C,
/* 0x95 */   CHAN_C|NONEOS_C,
/* 0x96 */   CHAN_C|NONEOS_C,
/* 0x97 */   CHAN_C|NONEOS_C,
/* 0x98 */   CHAN_C|NONEOS_C,
/* 0x99 */   CHAN_C|NONEOS_C,
/* 0x9A */   CHAN_C|NONEOS_C,
/* 0x9B */   CHAN_C|NONEOS_C,
/* 0x9C */   CHAN_C|NONEOS_C,
/* 0x9D */   CHAN_C|NONEOS_C,
/* 0x9E */   CHAN_C|NONEOS_C,
/* 0x9F */   CHAN_C|NONEOS_C,
/* 0xA0 */   NONEOS_C,
#ifndef KOREAN
/* 0xA1 */   CHAN_C|NONEOS_C,
/* 0xA2 */   CHAN_C|NONEOS_C,
/* 0xA3 */   CHAN_C|NONEOS_C,
/* 0xA4 */   CHAN_C|NONEOS_C,
/* 0xA5 */   CHAN_C|NONEOS_C,
/* 0xA6 */   CHAN_C|NONEOS_C,
/* 0xA7 */   CHAN_C|NONEOS_C,
/* 0xA8 */   CHAN_C|NONEOS_C,
/* 0xA9 */   CHAN_C|NONEOS_C,
/* 0xAA */   CHAN_C|NONEOS_C,
/* 0xAB */   CHAN_C|NONEOS_C,
/* 0xAC */   CHAN_C|NONEOS_C,
/* 0xAD */   CHAN_C|NONEOS_C,
/* 0xAE */   CHAN_C|NONEOS_C,
/* 0xAF */   CHAN_C|NONEOS_C,
/* 0xB0 */   CHAN_C|NONEOS_C,
/* 0xB1 */   CHAN_C|NONEOS_C,
/* 0xB2 */   CHAN_C|NONEOS_C,
/* 0xB3 */   CHAN_C|NONEOS_C,
/* 0xB4 */   CHAN_C|NONEOS_C,
/* 0xB5 */   CHAN_C|NONEOS_C,
/* 0xB6 */   CHAN_C|NONEOS_C,
/* 0xB7 */   CHAN_C|NONEOS_C,
/* 0xB8 */   CHAN_C|NONEOS_C,
/* 0xB9 */   CHAN_C|NONEOS_C,
/* 0xBA */   CHAN_C|NONEOS_C,
/* 0xBB */   CHAN_C|NONEOS_C,
/* 0xBC */   CHAN_C|NONEOS_C,
/* 0xBD */   CHAN_C|NONEOS_C,
/* 0xBE */   CHAN_C|NONEOS_C,
/* 0xBF */   CHAN_C|NONEOS_C,
/* 0xC0 */   CHAN_C|NONEOS_C,
/* 0xC1 */   CHAN_C|NONEOS_C,
/* 0xC2 */   CHAN_C|NONEOS_C,
/* 0xC3 */   CHAN_C|NONEOS_C,
/* 0xC4 */   CHAN_C|NONEOS_C,
/* 0xC5 */   CHAN_C|NONEOS_C,
/* 0xC6 */   CHAN_C|NONEOS_C,
/* 0xC7 */   CHAN_C|NONEOS_C,
/* 0xC8 */   CHAN_C|NONEOS_C,
/* 0xC9 */   CHAN_C|NONEOS_C,
/* 0xCA */   CHAN_C|NONEOS_C,
/* 0xCB */   CHAN_C|NONEOS_C,
/* 0xCC */   CHAN_C|NONEOS_C,
/* 0xCD */   CHAN_C|NONEOS_C,
/* 0xCE */   CHAN_C|NONEOS_C,
/* 0xCF */   CHAN_C|NONEOS_C,
/* 0xD0 */   CHAN_C|NONEOS_C,
/* 0xD1 */   CHAN_C|NONEOS_C,
/* 0xD2 */   CHAN_C|NONEOS_C,
/* 0xD3 */   CHAN_C|NONEOS_C,
/* 0xD4 */   CHAN_C|NONEOS_C,
/* 0xD5 */   CHAN_C|NONEOS_C,
/* 0xD6 */   CHAN_C|NONEOS_C,
/* 0xD7 */   CHAN_C|NONEOS_C,
/* 0xD8 */   CHAN_C|NONEOS_C,
/* 0xD9 */   CHAN_C|NONEOS_C,
/* 0xDA */   CHAN_C|NONEOS_C,
/* 0xDB */   CHAN_C|NONEOS_C,
/* 0xDC */   CHAN_C|NONEOS_C,
/* 0xDD */   CHAN_C|NONEOS_C,
/* 0xDE */   CHAN_C|NONEOS_C,
/* 0xDF */   CHAN_C|NONEOS_C,
#else /* KOREAN */
/*		
   According to KSC-5601 standard, a code between 0xA1A1 - 0xFEFE is
   only valid for Hangul code.
        	
	- Cocoja.
*/
/* 0xA1 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xA2 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xA3 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xA4 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xA5 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xA6 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xA7 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xA8 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xA9 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xAA */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xAB */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xAC */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xAD */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xAE */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xAF */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xB0 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xB1 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xB2 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xB3 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xB4 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xB5 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xB6 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xB7 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xB8 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xB9 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xBA */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xBB */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xBC */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xBD */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xBE */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xBF */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xC0 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xC1 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xC2 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xC3 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xC4 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xC5 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xC6 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xC7 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xC8 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xC9 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xCA */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xCB */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xCC */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xCD */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xCE */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xCF */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xD0 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xD1 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xD2 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xD3 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xD4 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xD5 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xD6 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xD7 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xD8 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xD9 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xDA */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xDB */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xDC */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xDD */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xDE */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xDF */   CHAN_C|NONEOS_C|HANGUL_C,
#endif /* KOREAN */
#ifndef HEBREW_SUPPORT
#ifndef KOREAN
/* 0xE0 */   CHAN_C|NONEOS_C,
/* 0xE1 */   CHAN_C|NONEOS_C,
/* 0xE2 */   CHAN_C|NONEOS_C,
/* 0xE3 */   CHAN_C|NONEOS_C,
/* 0xE4 */   CHAN_C|NONEOS_C,
/* 0xE5 */   CHAN_C|NONEOS_C,
/* 0xE6 */   CHAN_C|NONEOS_C,
/* 0xE7 */   CHAN_C|NONEOS_C,
/* 0xE8 */   CHAN_C|NONEOS_C,
/* 0xE9 */   CHAN_C|NONEOS_C,
/* 0xEA */   CHAN_C|NONEOS_C,
/* 0xEB */   CHAN_C|NONEOS_C,
/* 0xEC */   CHAN_C|NONEOS_C,
/* 0xED */   CHAN_C|NONEOS_C,
/* 0xEE */   CHAN_C|NONEOS_C,
/* 0xEF */   CHAN_C|NONEOS_C,
/* 0xF0 */   CHAN_C|NONEOS_C,
/* 0xF1 */   CHAN_C|NONEOS_C,
/* 0xF2 */   CHAN_C|NONEOS_C,
/* 0xF3 */   CHAN_C|NONEOS_C,
/* 0xF4 */   CHAN_C|NONEOS_C,
/* 0xF5 */   CHAN_C|NONEOS_C,
/* 0xF6 */   CHAN_C|NONEOS_C,
/* 0xF7 */   CHAN_C|NONEOS_C,
/* 0xF8 */   CHAN_C|NONEOS_C,
/* 0xF9 */   CHAN_C|NONEOS_C,
/* 0xFA */   CHAN_C|NONEOS_C,
#else /* KOREAN */
/* 0xE0 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xE1 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xE2 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xE3 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xE4 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xE5 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xE6 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xE7 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xE8 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xE9 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xEA */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xEB */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xEC */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xED */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xEE */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xEF */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xF0 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xF1 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xF2 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xF3 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xF4 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xF5 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xF6 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xF7 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xF8 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xF9 */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xFA */   CHAN_C|NONEOS_C|HANGUL_C,
#endif /* KOREAN */
#else /* HEBREW */
/* 0xE0 */   CHAN_C|NONEOS_C|NICK_C,
/* 0xE1 */   CHAN_C|NONEOS_C|NICK_C,
/* 0xE2 */   CHAN_C|NONEOS_C|NICK_C,
/* 0xE3 */   CHAN_C|NONEOS_C|NICK_C,
/* 0xE4 */   CHAN_C|NONEOS_C|NICK_C,
/* 0xE5 */   CHAN_C|NONEOS_C|NICK_C,
/* 0xE6 */   CHAN_C|NONEOS_C|NICK_C,
/* 0xE7 */   CHAN_C|NONEOS_C|NICK_C,
/* 0xE8 */   CHAN_C|NONEOS_C|NICK_C,
/* 0xE9 */   CHAN_C|NONEOS_C|NICK_C,
/* 0xEA */   CHAN_C|NONEOS_C|NICK_C,
/* 0xEB */   CHAN_C|NONEOS_C|NICK_C,
/* 0xEC */   CHAN_C|NONEOS_C|NICK_C,
/* 0xED */   CHAN_C|NONEOS_C|NICK_C,
/* 0xEE */   CHAN_C|NONEOS_C|NICK_C,
/* 0xEF */   CHAN_C|NONEOS_C|NICK_C,
/* 0xF0 */   CHAN_C|NONEOS_C|NICK_C,
/* 0xF1 */   CHAN_C|NONEOS_C|NICK_C,
/* 0xF2 */   CHAN_C|NONEOS_C|NICK_C,
/* 0xF3 */   CHAN_C|NONEOS_C|NICK_C,
/* 0xF4 */   CHAN_C|NONEOS_C|NICK_C,
/* 0xF5 */   CHAN_C|NONEOS_C|NICK_C,
/* 0xF6 */   CHAN_C|NONEOS_C|NICK_C,
/* 0xF7 */   CHAN_C|NONEOS_C|NICK_C,
/* 0xF8 */   CHAN_C|NONEOS_C|NICK_C,
/* 0xF9 */   CHAN_C|NONEOS_C|NICK_C,
/* 0xFA */   CHAN_C|NONEOS_C|NICK_C,
#endif /* HEBREW_SUPPORT */
#ifndef KOREAN
/* 0xFB */   CHAN_C|NONEOS_C,
/* 0xFC */   CHAN_C|NONEOS_C,
/* 0xFD */   CHAN_C|NONEOS_C,
/* 0xFE */   CHAN_C|NONEOS_C,
#else
/* 0xFB */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xFC */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xFD */   CHAN_C|NONEOS_C|HANGUL_C,
/* 0xFE */   CHAN_C|NONEOS_C|HANGUL_C,
#endif /* KOREAN */
/* 0xFF */   NONEOS_C
};
